uniform vec4 lightPosition;

attribute vec3 tangent;
attribute vec3 binormal;

varying vec3 localLightDirection;
varying vec3 localViewerDirection;

void main()
{
	gl_TexCoord[ 0 ] = gl_MultiTexCoord0;
	// tranform the position using the fixed-function transform
	// -> invariance
	gl_Position = ftransform();
	
	vec4 lightDirection = gl_ModelViewMatrixInverse * lightPosition - gl_Vertex;
	
	const vec4 viewer = vec4( 0.0, 0.0, 0.0, 1.0 );
	vec4 viewerDirection = gl_ModelViewMatrixInverse * viewer - gl_Vertex;
	
	// tangent-space to world-space matrix
	mat3 tangentSpace = mat3( tangent, binormal, gl_Normal );
	localLightDirection = vec3( lightDirection ) * tangentSpace;	
	
	localViewerDirection = vec3( viewerDirection ) * tangentSpace;	
} 
